Unaffiliated BFD Echo
Weiqiang Cheng
China Mobile
Beijing
China
chengweiqiang@chinamobile.com
Ruixue Wang
China Mobile
Beijing
China
wangruixue@chinamobile.com
Xiao Min, Ed.
ZTE Corp.
Nanjing
China
xiao.min2@zte.com.cn
Reshad Rahman
Individual
Kanata
Canada
reshad@yahoo.com
Raj Chetan Boddireddy
Juniper Networks
rchetan@juniper.net
2022
Routing
BFD Working Group
Request for Comments
RFC
Internet Draft
I-D
Bidirectional Forwarding Detection (BFD) is a fault detection protocol that can quickly determine a communication failure between two forwarding engines. This document proposes a use of the BFD Echo where the local system supports BFD but the neighboring system does not support BFD.
This document updates RFC 5880.

Introduction
To minimize the impact of device/link faults on services and improve network availability, a network device must be able to quickly detect faults in communication with adjacent devices. Measures can then be taken to promptly rectify the faults to ensure service continuity.
BFD [RFC5880] is a low-overhead, short-duration method to detect faults on the communication path between adjacent forwarding engines. The faults can be on interfaces, data link(s), and even the forwarding engines. It is a single, unified mechanism to monitor any media and protocol layers in real time.
BFD defines Asynchronous and Demand modes to satisfy various deployment scenarios. It also supports an Echo function to reduce the device requirement for BFD. When the Echo function is activated, the local system sends BFD Echo packets and the remote system loops back the received Echo packets through the forwarding path. If several consecutive BFD Echo packets are not received by the local system, then the BFD session is declared to be Down.
When using BFD Echo function, there are two typical scenarios as below:
- Full BFD protocol capability with affiliated Echo function. This scenario requires both the local device and the neighboring device to support the full BFD protocol.
- BFD Echo-Only method without full BFD protocol capability. This scenario requires only the local device to support sending and demultiplexing BFD Control packets.
The latter scenario is referred to as Unaffiliated BFD Echo in this document.
Section 6.2.2 of [BBF-TR-146] describes one use case of the Unaffiliated BFD Echo. Section 2 of [I-D.wang-bfd-one-arm-use-case] describes another use case of the Unaffiliated BFD Echo.
This document describes the use of the Unaffiliated BFD Echo over IPv4 and IPv6 for single IP hop.

Conventions Used in This Document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Updates to RFC 5880
The Unaffiliated BFD Echo described in this document reuses the BFD Echo function as described in [RFC5880] and [RFC5881], but does not require BFD Asynchronous or Demand mode. When using the Unaffiliated BFD Echo, only the local system has the BFD protocol enabled; the remote system just loops back the received BFD Echo packets as regular data packets.
This document updates [RFC5880] with respect to its descriptions on the BFD Echo function as follows.
The 4th paragraph of Section 3.2 of [RFC5880] is updated as below:
OLD TEXT
An adjunct to both modes is the Echo function.
NEW TEXT
An adjunct to both modes is the Echo function, which can also be running independently.
OLD TEXT
Since the Echo function is handling the task of detection, the rate of periodic transmission of Control packets may be reduced (in the case of Asynchronous mode) or eliminated completely (in the case of Demand mode).
NEW TEXT
Since the Echo function is handling the task of detection, the rate of periodic transmission of Control packets may be reduced (in the case of Asynchronous mode) or eliminated completely (in the case of Demand mode). The Echo function may also be used independently, with neither Asynchronous nor Demand mode.
The 3rd and 9th paragraphs of Section 6.1 of [RFC5880] are updated as below:
OLD TEXT
Once the BFD session is Up, a system can choose to start the Echo function if it desires and the other system signals that it will allow it. The rate of transmission of Control packets is typically kept low when the Echo function is active.
NEW TEXT
When a system is running with Asynchronous or Demand mode, once the BFD session is Up, it can choose to start the Echo function if it desires and the other system signals that it will allow it. The rate of transmission of Control packets is typically kept low for Asynchronous mode or eliminated completely for Demand mode when the Echo function is active.
OLD TEXT
If the session goes Down, the transmission of Echo packets (if any) ceases, and the transmission of Control packets goes back to the slow rate.
NEW TEXT
In Asynchronous mode, if the session goes Down, the transmission of Echo packets (if any) ceases, and the transmission of Control packets goes back to the slow rate. Demand mode MUST NOT be active if the session goes Down.
The 2nd paragraph of Section 6.4 of [RFC5880] is updated as below:
OLD TEXT
When a system is using the Echo function, it is advantageous to choose a sedate reception rate for Control packets, since liveness detection is being handled by the Echo packets. This can be controlled by manipulating the Required Min RX Interval field (see section 6.8.3).
NEW TEXT
When a system is using the Echo function with Asynchronous mode, it is advantageous to choose a sedate reception rate for Control packets, since liveness detection is being handled by the Echo packets. This can be controlled by manipulating the Required Min RX Interval field (see section 6.8.3). Note that a system operating in Demand mode would direct the remote system to cease the periodic transmission of BFD Control packets, by setting the Demand (D) bit in its BFD Control packets.
The 2nd paragraph of Section 6.8 of [RFC5880] is updated as below:
OLD TEXT
When a system is said to have "the Echo function active" it means that the system is sending BFD Echo packets, implying that the session is Up and the other system has signaled its willingness to loop back Echo packets.
NEW TEXT
When a system in Asynchronous or Demand mode is said to have "the Echo function active" it means that the system is sending BFD Echo packets, implying that the session is Up and the other system has signaled its willingness to loop back Echo packets.
The 7th paragraph of Section 6.8.3 of [RFC5880] is updated as below:
OLD TEXT
When the Echo function is active, a system SHOULD set bfd.RequiredMinRxInterval to a value of not less than one second (1,000,000 microseconds). This is intended to keep received BFD Control traffic at a negligible level, since the actual detection function is being performed using BFD Echo packets.
NEW TEXT
When the Echo function is active with Asynchronous mode, a system SHOULD set bfd.RequiredMinRxInterval to a value of not less than one second (1,000,000 microseconds). This is intended to keep received BFD Control traffic at a negligible level, since the actual detection function is being performed using BFD Echo packets. While a system operating in Demand mode would not receive BFD Control traffic.
The 1st and 2nd paragraphs of Section 6.8.9 of [RFC5880] are updated as below:
OLD TEXT
BFD Echo packets MUST NOT be transmitted when bfd.SessionState is not Up. BFD Echo packets MUST NOT be transmitted unless the last BFD Control packet received from the remote system contains a nonzero value in Required Min Echo RX Interval.
NEW TEXT
When a system is using the Echo function with either Asynchronous or Demand mode, BFD Echo packets MUST NOT be transmitted when bfd.SessionState is not Up, and BFD Echo packets MUST NOT be transmitted unless the last BFD Control packet received from the remote system contains a nonzero value in Required Min Echo RX Interval.
OLD TEXT
BFD Echo packets MAY be transmitted when bfd.SessionState is Up. The interval between transmitted BFD Echo packets MUST NOT be less than the value advertised by the remote system in Required Min Echo RX Interval...
NEW TEXT
When a system is using the Echo function with either Asynchronous or Demand mode, BFD Echo packets MAY be transmitted when bfd.SessionState is Up, and the interval between transmitted BFD Echo packets MUST NOT be less than the value advertised by the remote system in Required Min Echo RX Interval...

Unaffiliated BFD Echo Procedures

Unaffiliated BFD Echo diagram

Device A                                  Device B

BFD Enabled                               BFD Echo packets loopback
+--------+        BFD Echo session        +--------+
|   A    |--------------------------------|   B    |
|        |Interface 1          Interface 1|        |
+--------+                                +--------+
BFD is supported.               BFD is not supported.

As shown in Figure 1, device A supports BFD, whereas device B does not support BFD. Device A would send BFD Echo packets, and after receiving the BFD Echo packets sent from device A, the one-hop-away BFD peer device B immediately loops them back by normal IP forwarding, this allows device A to rapidly detect a connectivity loss to device B. Note that device B would not intercept any received BFD Echo packet or parse any BFD protocol field within the BFD Echo packet.
To rapidly detect any IP forwarding faults between device A and device B, a BFD Echo session MUST be created at device A, and the BFD Echo session MUST follow the BFD state machine defined in Section 6.2 of [RFC5880], except that the received state is not sent but echoed from the remote system, and AdminDown state is ruled out because AdminDown effectively means removal of BFD Echo session. In this case, although BFD Echo packets are transmitted with destination UDP port 3785 as defined in [RFC5881], the BFD Echo packets sent by device A are BFD Control packets too, the looped BFD Echo packets back from device B would drive BFD state change at device A, substituting the BFD Control packets sent from the BFD peer. Also note that when device A receives looped BFD Control packets, the validation procedures of [RFC5880] are used.
Once a BFD Echo session is created at device A, it starts sending BFD Echo packets, which MUST include BFD Echo session demultiplexing fields, such as BFD "Your Discriminator" defined in [RFC5880] (BFD "My Discriminator" can be set to 0 to avoid confusion), except for BFD "Your Discriminator", device A can also use IP source address or UDP source port to demultiplex BFD Echo session, or there is only one BFD Echo session running at device A. Device A would send BFD Echo packets with IP destination address destined for itself, such as the IP address of interface 1 of device A. All BFD Echo packets for the session MUST be sent with a Time to Live (TTL) or Hop Limit value of 255.
Within the BFD Echo packet, the "Desired Min TX Interval" and "Required Min RX Interval" defined in [RFC5880] may be populated with one second, which however has no real application and would be ignored by the receiver.
Considering that the BFD peer device B wouldn't advertise "Required Min Echo RX Interval" as defined in [RFC5880], the transmission interval for sending BFD Echo packets MUST be provisioned at device A, how to make sure the BFD peer device B is willing and able to loop back BFD Echo packets sent with the provisioned transmission interval is outside the scope of this document. Similar to what's specified in [RFC5880], the BFD Echo session begins with the periodic, slow transmission of BFD Echo packets, the slow transmission rate SHOULD be no less then one second per packet, until the session is Up, after that the provisioned transmission interval is applied, and reverting back to the slow rate once the session goes Down. Considering that the BFD peer wouldn't advertise "Detect Mult" as defined in [RFC5880], the "Detect Mult" for calculating the Detection Time MUST be provisioned at device A, the Detection Time at device A is equal to the provisioned "Detect Mult" multiplied by the provisioned transmission interval.

Unaffiliated BFD Echo Applicability
Some devices that would benefit from the use of BFD may be unable to support the full BFD protocol. Examples of such devices include servers running virtual machines, or Internet of Things (IoT) devices. The Unaffiliated BFD Echo can be used when two devices are connected and only one of them supports the BFD protocol, and the other is capable of looping BFD Echo packets.

Security Considerations
All Security Considerations from [RFC5880] and [RFC5881] apply.
Note that the Unaffiliated BFD Echo prevents the use of Unicast Reverse Path Forwarding (URPF) [RFC3704] [RFC8704] in strict mode.
As specified in Section 5 of [RFC5880], since BFD Echo packets may be spoofed, some form of authentication SHOULD be included. Considering the BFD Echo packets in this document are also BFD Control packets, the "Authentication Section" as defined in [RFC5880] for BFD Control packet is RECOMMENDED to be included within the BFD Echo packet.
In order to mitigate the potential reflector attack by the remote attackers, or infinite loop of the BFD Echo packets, it's RECOMMENDED to put two requirements on the device looping BFD Echo packets, the first one is that a packet SHOULD NOT be looped unless it has a TTL or Hop Limit value of 255, and the second one is that a packet being looped MUST NOT reset the TTL or Hop Limit value to 255, and MUST use a TTL or Hop Limit value of 254.

IANA Considerations
This document has no IANA action requested.

Acknowledgements
The authors would like to acknowledge Ketan Talaulikar, Greg Mirsky and Santosh Pallagatti for their careful review and very helpful comments.
The authors would like to acknowledge Jeff Haas for his insightful review and very helpful comments.

Contributors
Liu Aihua
ZTE
Email: liu.aihua@zte.com.cn
Qian Xin
ZTE
Email: qian.xin2@zte.com.cn
Zhao Yanhua
ZTE
Email: zhao.yanhua3@zte.com.cn

Normative References

Informative References
[BBF-TR-146]

BBF Technical Report - Subscriber Sessions Issue 1
Broadband Forum
2013
[RFC5880]
[I-D.wang-bfd-one-arm-use-case]
[RFC2119]
[RFC8174]
[RFC5881]
[RFC3704]
[RFC8704]